/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.openxma.dsl.dom.model;

import org.eclipse.emf.common.util.EList;
import org.openxma.dsl.core.model.IDocumentable;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Feature Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.openxma.dsl.dom.model.FeatureReference#getSource <em>Source</em>}</li>
 *   <li>{@link org.openxma.dsl.dom.model.FeatureReference#getAttribute <em>Attribute</em>}</li>
 *   <li>{@link org.openxma.dsl.dom.model.FeatureReference#getView <em>View</em>}</li>
 *   <li>{@link org.openxma.dsl.dom.model.FeatureReference#isAll <em>All</em>}</li>
 *   <li>{@link org.openxma.dsl.dom.model.FeatureReference#getProperties <em>Properties</em>}</li>
 *   <li>{@link org.openxma.dsl.dom.model.FeatureReference#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.openxma.dsl.dom.DomPackage#getFeatureReference()
 * @model
 * @generated
 */
public interface FeatureReference extends PresentableFeature, IDocumentable {
	/**
     * Returns the value of the '<em><b>Source</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>Source</em>' reference.
     * @see #setSource(Entity)
     * @see org.openxma.dsl.dom.DomPackage#getFeatureReference_Source()
     * @model
     * @generated
     */
	Entity getSource();

	/**
     * Sets the value of the '{@link org.openxma.dsl.dom.model.FeatureReference#getSource <em>Source</em>}' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @param value the new value of the '<em>Source</em>' reference.
     * @see #getSource()
     * @generated
     */
	void setSource(Entity value);

	/**
     * Returns the value of the '<em><b>Attribute</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Attribute</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>Attribute</em>' reference.
     * @see #setAttribute(Attribute)
     * @see org.openxma.dsl.dom.DomPackage#getFeatureReference_Attribute()
     * @model
     * @generated
     */
	Attribute getAttribute();

	/**
     * Sets the value of the '{@link org.openxma.dsl.dom.model.FeatureReference#getAttribute <em>Attribute</em>}' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @param value the new value of the '<em>Attribute</em>' reference.
     * @see #getAttribute()
     * @generated
     */
	void setAttribute(Attribute value);

	/**
     * Returns the value of the '<em><b>View</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>View</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>View</em>' reference.
     * @see #setView(DataView)
     * @see org.openxma.dsl.dom.DomPackage#getFeatureReference_View()
     * @model
     * @generated
     */
	DataView getView();

	/**
     * Sets the value of the '{@link org.openxma.dsl.dom.model.FeatureReference#getView <em>View</em>}' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @param value the new value of the '<em>View</em>' reference.
     * @see #getView()
     * @generated
     */
	void setView(DataView value);

	/**
     * Returns the value of the '<em><b>Properties</b></em>' containment reference list.
     * The list contents are of type {@link org.openxma.dsl.dom.model.AttributeProperty}.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Properties</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>Properties</em>' containment reference list.
     * @see org.openxma.dsl.dom.DomPackage#getFeatureReference_Properties()
     * @model containment="true"
     * @generated
     */
	EList<AttributeProperty> getProperties();

	/**
     * Returns the value of the '<em><b>All</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>All</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>All</em>' attribute.
     * @see #setAll(boolean)
     * @see org.openxma.dsl.dom.DomPackage#getFeatureReference_All()
     * @model
     * @generated
     */
	boolean isAll();

	/**
     * Sets the value of the '{@link org.openxma.dsl.dom.model.FeatureReference#isAll <em>All</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @param value the new value of the '<em>All</em>' attribute.
     * @see #isAll()
     * @generated
     */
	void setAll(boolean value);

	/**
     * Returns the value of the '<em><b>Target</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>Target</em>' reference.
     * @see org.openxma.dsl.dom.DomPackage#getFeatureReference_Target()
     * @model resolveProxies="false" transient="true" changeable="false" volatile="true" derived="true"
     * @generated
     */
	Attribute getTarget();
	
	/**
	 * @modified
	 */
	void setTarget(Attribute attribute);	

} // FeatureReference
